package re.jimmitry.apps974.furious;

import re.jimmitry.apps974.furious.*;

import re.jimmitry.apps974.fursys.*;

import re.jimmitry.apps974.wsfurious.*;

import re.jimmitry.apps974.wsfurious.xsd.*;

import java.net.*;

import java.io.*;

import java.util.*;

//---------------------------------------------------------------------------

public class LoadBalancerSAuth 

{

  static public String PILEIP = "";
  static public int indexPILE = 0;

  static public int NbSession = 0;
  static public long NbSessionOut = 0, nbConnectTOT=0;

  
  static public int OPEN = 0;

  static String strVersion = "1.0";

  static String strAbout = 

    "\r\nLoadBalancerSAuth - TCP/HTTP trace utility\r\n\r\n"+

    "Usage:  LoadBalancerSAuth -help\r\n\r\n"+

    "Version: " +strVersion+ " (see LoadBalancerSAuth.sourceforge.org)\r\n"+

    "Author:  Jimmitry PAYET";

  static String strUsage = 

    "\r\nUsage: java LoadBalancerSAuth {options}  or Win32 (Microsoft JVM): JVIEW LoadBalancerSAuth\r\n"+

    "\r\nOptions are:\r\n"+

    "  -listenport  \tTCP port on which LoadBalancerSAuth listens (default: 80)\r\n"+

    "  -tunnelhost  \thostname to which LoadBalancerSAuth redirects data  (default: localhost)\r\n"+

    "  -tunnelport  \tport to which LoadBalancerSAuth redirects data (default: 80)\r\n"+

    "  -tracefile   \tappend data to this file.\r\n"+

    "               \tuse \"-tracefile stdout\" to write to console.\r\n"+

    "  -pattern     \ttrace only data containing this text (enclosed in \"\")\r\n"+

    "  -nodata      \tdo not trace data\r\n"+

    "  -noheader    \tdo not trace HTTP header\r\n"+

    "  -nodialog    \tdo not display parameter dialog on startup\r\n"+

    "  -nocomments  \tdo not write any comments\r\n"+

    "  -nogui       \tdo not display graphical user interface\r\n"+

    "  -help        \tprint this help\r\n"+

    "  -version     \tprint version\r\n"+

    "\r\nSamples:\r\n"+

    "Listen on port 80 and send requests to www.xyz.com : \r\n"+

    "  java LoadBalancerSAuth -tunnelhost www.xyz.com\r\n\r\n"+

    "Listen on port 80 and send requests to local port 81, omit HTTP header : \r\n"+

    "  java LoadBalancerSAuth -tunnelport 81 -noheader\r\n\r\n"+

    "Listen on port 80 and send requests to localhost port 6714, but don't display\r\n"+

    "window. Print every packet containing \"<?xml\" on console :\r\n"+

    "  java LoadBalancerSAuth -tunnelport 6714 -nogui -pattern \"<?xml\" -tracefile stdout \r\n";

  

  //LoadBalancerSAuth parameters:

  static int      iListenPort;

  static int      iTunnelPort;

  static String   strTunnelHost;

  static String   strTraceFile;

  static String   strPattern;

  static boolean  bDisplayData;

  static boolean  bDisplayHttpHeader;

  static boolean  bDisplayComments;

  static boolean  bLoadBalancerParameterDialogSAuth;

  static boolean  bGui;

  static FileWriter fTrace;

  //static LoadBalancerDataTunnelSAuth inLoadBalancerDataTunnelSAuth, outLoadBalancerDataTunnelSAuth;

  static public synchronized void exePILESQL(String IP, String HOST) throws Exception {
    String dttemp=Fur_Date.getSysDate2().substring(0,18);
    if (PILEIP.indexOf("@"+IP+"#"+dttemp)<0) {
      PILEIP="@"+IP+"#"+dttemp+"$"+HOST+"&"+PILEIP;
    }
    indexPILE++;
    if (indexPILE>=Integer.parseInt(FurPARAM.getDBSConnectorParam("TRACKING_PILEMAX_HTTPS_AUTH").DATA)) {
      FurPRGM_6.EXE(PILEIP.replace("@", "INSERT INTO SYSTEM_TRACELB (IP, DTACTION, HOST, LB) VALUES ('").replace("#","', '").replace("$","0', '").replace("&","', 3);"));
      PILEIP="";
      indexPILE=0;
    }
  }

//---------------------------------------------------------------------------

  public LoadBalancerSAuth () {    //the constructor inits the main window

  

    if(!bGui) return;      //if no GUI is desired, do not build the frame

    

    

    LoadBalancerParameterDialogSAuth dlg;



    

    //display parameter dialog:

    if(bLoadBalancerParameterDialogSAuth) {

      dlg = new LoadBalancerParameterDialogSAuth(this);

      

    }

    LoadBalancerTimeNowSAuth t = new LoadBalancerTimeNowSAuth();

    putComment(1, "LoadBalancerSAuth started at " + t.getDateTimeString() );   

    if(!bDisplayHttpHeader) {

      putComment(1, "HTTP headers are not displayed.");

    }

    if(!bDisplayData) {

      putComment(1, "Data is not displayed.");	

    }

    putComment(1, "listenport="+iListenPort+" tunnelhost=" + strTunnelHost+

               " tunnelport="+iTunnelPort);   

    if(strPattern.length() != 0) {

      putComment(1, "searching for pattern: "+strPattern);   

    }

    if(strTraceFile.length() != 0) {

      putComment(1, "writing to file: "+strTraceFile);   

    }

  }

//---------------------------------------------------------------------------

  //print a comment line to text area and trace file.

  //if level=1 then do not print if -nocomments is set

  public void putComment (int level, String txt) {

    if((bDisplayComments) || (level==0)) {

      String s = new String("\r\n> " + txt);

      WriteTraceFile(s);      

    }

  }

//---------------------------------------------------------------------------

  //write a string to the tracefile (if -tracefile ist set)

  public void WriteTraceFile(String s) {

    if(strTraceFile.length() != 0) 

    {

      if(strTraceFile.equalsIgnoreCase("stdout")) {

      	System.out.print(s);

      }

      else

      {

        try {

          fTrace = new FileWriter(strTraceFile, true);  //true=append

          fTrace.write(s);

          fTrace.close();

        } catch (IOException e) {

          System.err.println("cannot write to file " + strTraceFile);

          System.err.println(e.toString());

          return;

        }

      }

    }

  }

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------

  public static void main (String args[]) throws IOException {

	    

    if( ! processArgs( args ) ) {

      return;

    }

    

    //create the GUI:    

    final LoadBalancerSAuth ht = new LoadBalancerSAuth ();

    

    // create the server thread:

    Thread threadServer = new Thread () {

      public void run () {

	ServerSocket ss = null;

	try {

	  ss = new ServerSocket (ht.iListenPort);

	} catch (Exception e) {

	  e.printStackTrace ();

	  //System.exit (1);

	}

	while (true) {

	  

	  Socket sock1 = null;

	  try {

	    // accept the connection from client:

	    sock1 = ss.accept ();
        LoadBalancerSAuth.NbSession++;
        LoadBalancerSAuth.nbConnectTOT++;
        
        if (FurPARAM.getDBSConnectorParam("TRACKING_MEMORY").DATA.equals("True")) {
          long TMEMO=Runtime.getRuntime().totalMemory(), FMEMO=Runtime.getRuntime().freeMemory(), MMEMO=Runtime.getRuntime().maxMemory();
          Fur_File.Trace("Memory LBSAuth: "+(((long) TMEMO/1024/1024)-((long) FMEMO/1024/1024))+"/"+((long) TMEMO/1024/1024)+"/"+((long) MMEMO/1024/1024)+" Mo - "+((long) ((((long) TMEMO/1024/1024)-((long) FMEMO/1024/1024))*100/((long) TMEMO/1024/1024)))+"% used memory ... NbSession="+NbSession+"/NbSessionOut="+NbSessionOut);
          
        }

	    new LoadBalancerSAuthSTARTTunnelSAuth (ht,sock1).start();

	  } catch (Exception ee) {}

	}

      }

    };

    threadServer.start ();

  }

//---------------------------------------------------------------------------

  //read parameters from command line:

  public static boolean processArgs(String[] args) {

    iListenPort        = 80;             //defaults

    strTunnelHost      = "localhost";

    iTunnelPort        = 80;

    strTraceFile       = "";

    strPattern         = "";

    bDisplayHttpHeader = true; 

    bDisplayData       = true;

    bDisplayComments   = true;

    bLoadBalancerParameterDialogSAuth   = true;

    bGui               = true;

    

    for (int i = 0; i < args.length; i++) {

      String arg = args[i];

	 

      if (arg.equalsIgnoreCase("-help") || 

          arg.equalsIgnoreCase("help") || 

          arg.equalsIgnoreCase("-?") || arg.equalsIgnoreCase("/?")) {

	System.out.println(strUsage);

	return false;

      } else if (arg.equalsIgnoreCase("-listenport")) {

	i++; iListenPort = Integer.parseInt (args[i]);

      } else if (arg.equalsIgnoreCase("-tunnelport")) {

	i++; iTunnelPort = Integer.parseInt (args[i]);

      } else if (arg.equalsIgnoreCase("-tunnelhost")) {

	i++; strTunnelHost = args[i];

      } else if (arg.equalsIgnoreCase("-tracefile")) {

	i++; strTraceFile = args[i];

      } else if (arg.equalsIgnoreCase("-pattern")) {

	i++; strPattern = args[i];

      } else if (arg.equalsIgnoreCase("-nodata")) {

	bDisplayData = false;

      } else if (arg.equalsIgnoreCase("-noheader")) {

	bDisplayHttpHeader = false;

      } else if (arg.equalsIgnoreCase("-nocomments")) {

	bDisplayComments = false;

      } else if (arg.equalsIgnoreCase("-nodialog")) {

	bLoadBalancerParameterDialogSAuth = false;

      } else if (arg.equalsIgnoreCase("-nogui")) {

	bGui = false;

      } else if (arg.equalsIgnoreCase("-version")) {

	System.out.println(strAbout);

        return false;

      } else {

	System.out.println(strAbout);

        return false;

      }

    }        

    return true;

  }        

}  //end of class LoadBalancerSAuth





//---------------------------------------------------------------------------

class LoadBalancerParameterDialogSAuth 

{

  LoadBalancerSAuth ht;

  

  public LoadBalancerParameterDialogSAuth(LoadBalancerSAuth ht)

  {

    //super(ht, "LoadBalancerSAuth Parameters:", true);



    this.ht = ht;

    

  }

  

}





//---------------------------------------------------------------------------

class LoadBalancerTimeNowSAuth

{

  GregorianCalendar cal;            

  String strTime;

  

  LoadBalancerTimeNowSAuth() {

    cal = new GregorianCalendar();

  }

  

  public String getDateTimeString() {

    strTime = cal.get(Calendar.YEAR)        + "/" + 

              cal.get(Calendar.MONTH)       + "/" +

              cal.get(Calendar.DATE)        + " " +

              cal.get(Calendar.HOUR_OF_DAY) + ":" +

              cal.get(Calendar.MINUTE)      + ":" +

              cal.get(Calendar.SECOND);

    return(strTime);

  }



  public String getTimeString() {

    strTime = cal.get(Calendar.HOUR_OF_DAY) + ":" +

              cal.get(Calendar.MINUTE)      + ":" +

              cal.get(Calendar.SECOND);

    return(strTime);

  }

}



class LoadBalancerSAuthSTARTTunnelSAuth extends Thread {

LoadBalancerSAuth ht;

Socket sock1;

  LoadBalancerSAuthSTARTTunnelSAuth (LoadBalancerSAuth ht,Socket sock1) 

  {

    this.ht = ht;

    this.sock1 = sock1;

  }

  public void run () {

    String[] retour = {"", ""};boolean b=false;

    try {

      // connect to the thing I'm tunnelling for

      if (LoadBalancerSAuth.OPEN==1) {
        retour=FurPRGM_6.getHostFromCluster();
        if (FurPARAM.getDBSConnectorParam("LB_HTTPS_AUTH_TRACKING_IP").DATA.equals("True")) LoadBalancerSAuth.exePILESQL(sock1.getInetAddress().getHostAddress(), sock1.getInetAddress().getHostName());
        
      }

      if (LoadBalancerSAuth.OPEN==1 && FurPRGM_6.isUNBLOKEDIP(sock1.getInetAddress().getHostAddress()) && retour!=null && !retour[0].equals("") && LoadBalancerSAuth.NbSession<=Integer.parseInt(FurPARAM.getDBSConnectorParam("LOADBALANCER_SESSION_MAX_HTTPS_AUTH").DATA)) {

        Socket sock2 = new Socket();

        final int TIMEOUT = Integer.parseInt(FurPARAM.getDBSConnectorParam("LOADBALANCER_SESSION_TIMEOUT_HTTPS_AUTH").DATA);

        sock2.setSoTimeout(TIMEOUT);

        try {sock2.connect(new InetSocketAddress(retour[1], ht.iTunnelPort), TIMEOUT);b=true;} catch (Exception r) {

          FurPRGM_6.expulsHostFromCluster(retour[0], "Can't connect to "+retour[1]+":"+ht.iTunnelPort+" ...");

          retour=FurPRGM_6.getHostFromCluster();

          if (retour!=null && !retour[0].equals("")) {

            sock2 = new Socket();

            sock2.setSoTimeout(TIMEOUT);

            try {sock2.connect(new InetSocketAddress(retour[1], ht.iTunnelPort), TIMEOUT);b=true;} catch (Exception rr) {sock1.close();}

          } else {

            sock1.close();

          }

        }

        if (b) {

          LoadBalancerDataTunnelSAuth startLOADB = new LoadBalancerDataTunnelSAuth (ht, this.sock1.getInputStream (), 

                            sock2.getOutputStream (),

	                    "Request", retour, "MASTER", this.sock1.getInetAddress().getHostAddress());

	        startLOADB.start ();

	        new LoadBalancerDataTunnelSAuthgentSAuth(startLOADB).start ();

	        //Thread.currentThread().sleep(10000);

          try {
          
           LoadBalancerDataTunnelSAuth startLOADBResp = new LoadBalancerDataTunnelSAuth (ht, sock2.getInputStream (), 

                              this.sock1.getOutputStream (),

	                      "Response", retour, "SLAVE", "");
	                      startLOADBResp.start ();
	                      
	          //new LoadBalancerDataTunnelSAuthgentSAuth(startLOADBResp).start ();
	                      
	                      } catch (Exception f) {/*Err socket close*/}             

	      }

      } else {this.sock1.close();LoadBalancerSAuth.NbSession--;LoadBalancerSAuth.NbSessionOut++;}

      

    } catch (Exception e) {

    }

  }

}



//---------------------------------------------------------------------------

//this thread is started twice: 

//one thread for the client request, the other for the server response.

class LoadBalancerDataTunnelSAuth extends Thread {

  final static int BUFSIZ = 1000;

  public InputStream in;
  BufferedReader inBR;

  public OutputStream out;
  PrintWriter outPW;
  BufferedWriter outBR;
  boolean PPassage=true;

  byte buf[] = new byte[BUFSIZ];

  String direction, Type, IPClient;

  LoadBalancerSAuth ht;

  String[] retour=null;

  public long life= System.currentTimeMillis();

  LoadBalancerDataTunnelSAuth (LoadBalancerSAuth ht,InputStream in,OutputStream out,String direction, String[] retour, String Type, String IPClient) 

  {

    this.ht = ht;
    this.IPClient=IPClient;
    this.in = in;

    this.out = out;

    this.direction = direction;

    this.retour=retour;

    this.Type=Type;

  }

  public void run () {

    int n;
    try {
      
      while ((n = in.read (buf)) > 0) {
	       //write to TCPIP port:
	       out.write (buf, 0, n);
	       out.flush ();
        life=System.currentTimeMillis();
      }
      

    } catch (Exception e) {}

finally {

try {

	
	  in.close ();
   out.close ();
 

      } catch (IOException e) {}

    }

    if (!FurPRGM_6.exeHostFromCluster(retour[0])) {FurPRGM_6.expulsHostFromCluster(retour[0], "Persiste NBEXE to SYSTEM_CLUSTER table error.");}

  }

}

class LoadBalancerDataTunnelSAuthgentSAuth extends Thread {

  LoadBalancerDataTunnelSAuth datatunel=null;

  LoadBalancerDataTunnelSAuthgentSAuth (LoadBalancerDataTunnelSAuth datatunel) 

  {

    this.datatunel = datatunel;

  }

  public void run () {

    
    while (datatunel.isAlive()) {

      if ((datatunel.life+ Long.parseLong(FurPARAM.getDBSConnectorParam("LOADBALANCER_LIFE_TIMEOUT_HTTPS_AUTH").DATA)) < System.currentTimeMillis()) {

	      break;

      }

      try {

	      Thread.sleep(500);

      }

      catch (InterruptedException t) {}

    }

    //try {

    try {

	if (datatunel.isAlive()) { this.datatunel.in.close ();

	  this.datatunel.out.close ();}

      } catch (IOException e) {}

    //this.datatunel.interrupt();} catch (Exception e) {}

    LoadBalancerSAuth.NbSession--;

  }

}



//---------------------------------------------------------------------------

//end of LoadBalancerSAuth.java

